<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderStats".
 *
 * Columns in table "provider_stats" available as properties of the model,
 * followed by relations of table "provider_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $search_views
 * @property string $profile_views
 * @property string $phone_views
 * @property string $fax_views
 * @property string $email_views
 * @property string $website_views
 *
 * @property Provider $provider
 */
abstract class BaseProviderStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_stats';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id', 'required'),
            array('provider_id', 'numerical', 'integerOnly' => true),
            array('search_views, profile_views, phone_views, fax_views, email_views, website_views', 'length',
                'max' => 10),
            array('search_views, profile_views, phone_views, fax_views, email_views, website_views', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, search_views, profile_views, phone_views, fax_views, email_views, website_views',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'search_views' => Yii::t('app', 'Search Views'),
            'profile_views' => Yii::t('app', 'Profile Views'),
            'phone_views' => Yii::t('app', 'Phone Views'),
            'fax_views' => Yii::t('app', 'Fax Views'),
            'email_views' => Yii::t('app', 'Email Views'),
            'website_views' => Yii::t('app', 'Website Views'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('search_views', $this->search_views, true);
        $criteria->compare('profile_views', $this->profile_views, true);
        $criteria->compare('phone_views', $this->phone_views, true);
        $criteria->compare('fax_views', $this->fax_views, true);
        $criteria->compare('email_views', $this->email_views, true);
        $criteria->compare('website_views', $this->website_views, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderStats|ProviderStats', $n);
    }

}
